VERSION 5.00
Begin VB.Form frmRestrictMouseCursor 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Using API Call Samples"
   ClientHeight    =   3990
   ClientLeft      =   3315
   ClientTop       =   3120
   ClientWidth     =   9150
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3990
   ScaleWidth      =   9150
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Close"
      Height          =   495
      Left            =   4080
      TabIndex        =   9
      Top             =   240
      Width           =   1215
   End
   Begin VB.Frame fme 
      Caption         =   "Lock Window Update"
      Height          =   3735
      Index           =   1
      Left            =   5520
      TabIndex        =   1
      Top             =   120
      Width           =   3495
      Begin VB.Timer Tmr 
         Interval        =   900
         Left            =   1560
         Top             =   240
      End
      Begin VB.CommandButton cmdUnlock 
         Caption         =   "Unlock Update"
         Height          =   375
         Left            =   1920
         TabIndex        =   3
         Top             =   600
         Width           =   1335
      End
      Begin VB.CommandButton CmdLock 
         Caption         =   "Lock Update"
         Height          =   375
         Left            =   240
         TabIndex        =   2
         Top             =   600
         Width           =   1335
      End
      Begin VB.Label LblTime 
         Alignment       =   2  'Center
         Caption         =   "LblTime"
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   15.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   855
         Left            =   240
         TabIndex        =   4
         Top             =   1680
         Width           =   3015
      End
   End
   Begin VB.Frame fme 
      Caption         =   "Restrict Mouse"
      Height          =   3735
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3735
      Begin VB.CommandButton cmdRestrictCursor 
         Caption         =   "Restrict Cursor Position To This Window"
         Height          =   375
         Index           =   0
         Left            =   240
         TabIndex        =   8
         Top             =   360
         Width           =   3255
      End
      Begin VB.PictureBox Picture1 
         Height          =   2175
         Left            =   240
         ScaleHeight     =   2115
         ScaleWidth      =   3195
         TabIndex        =   6
         Top             =   1320
         Width           =   3255
         Begin VB.CommandButton cmdReleaseCursor 
            Caption         =   "Release Cursor"
            Height          =   375
            Left            =   120
            TabIndex        =   7
            Top             =   1680
            Width           =   2970
         End
      End
      Begin VB.CommandButton cmdRestrictCursor 
         Caption         =   "Restrict Cursor Position To Box Below"
         Height          =   375
         Index           =   1
         Left            =   240
         TabIndex        =   5
         Top             =   840
         Width           =   3255
      End
   End
End
Attribute VB_Name = "frmRestrictMouseCursor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type POINT
   x As Long
   y As Long
End Type

Private Type RECT
   Left   As Integer
   Top    As Integer
   Right  As Integer
   Bottom As Integer
End Type

' These API declarations are for restricting the mouse cursor position
Private Declare Sub ClipCursor Lib "user32" (lpRect As Any)
Private Declare Sub GetClientRect Lib "user32" (ByVal Hwnd As Long, lpRect As RECT)
Private Declare Sub ClientToScreen Lib "user32" (ByVal Hwnd As Long, lpPoint As POINT)
Private Declare Sub OffsetRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal y As Long)


' This API declaration is for the screen lock update
Private Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long


Private Sub cmdClose_Click()
  Unload Me
End Sub

Private Sub CmdLock_Click()
  Dim Ret As Long
  
  Ret = LockWindowUpdate(Me.Hwnd)
End Sub

Private Sub CmdReleaseCursor_Click()
  ' release the cursor's restrictions
  Call ClipCursor(0&)
End Sub

Private Sub CmdRestrictCursor_Click(Index As Integer)
  Dim Ctrl      As RECT
  Dim Hwnd      As Long
  Dim UpperLeft As POINT

  'Limits the Cursor movement to within an object/control
  Select Case Index
    Case Is = 0: Hwnd = Me.Hwnd
    Case Is = 1: Hwnd = Picture1.Hwnd
  End Select
  
  ' get the Rectangle of the control we are restricting to
  Call GetClientRect(Hwnd, Ctrl)
  
  ' remember the top XY coordinate of the control
  UpperLeft.x = Ctrl.Left
  UpperLeft.y = Ctrl.Top
  
  ' Find the controls coordinates in relation to the screen and set the restriction rectangle
  Call ClientToScreen(Hwnd, UpperLeft)
  Call OffsetRect(Ctrl, UpperLeft.x, UpperLeft.y)
  Call ClipCursor(Ctrl)
End Sub

Private Sub cmdUnlock_Click()
  Dim Ret As Long
  
  Ret = LockWindowUpdate(0&)
End Sub

Private Sub Form_Load()
  Call Tmr_Timer
End Sub

Private Sub Form_Unload(Cancel As Integer)
  ' release the cursor's restrictions
  Call CmdReleaseCursor_Click
End Sub

Private Sub Tmr_Timer()
  LblTime = Time
End Sub
